<?
	/*
	 * Eventmanager - Manage and organize events, meetings, partys online 
	 * Copyright (C) 2006 
	 * Sven O. Gabel - Sven.O.Gabel@dynamicvisions.de
	 * 
	 * This program is free software; you can redistribute it and/or modify it under the terms of 
	 * the GNU General Public License as published by the Free Software Foundation; either 
	 * version 2 of the License, or (at your option) any later version.
	 * This program is distributed in the hope that it will be useful, 
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
	 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
	 * 
	 * You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA 
	 * TEST
	 */
?>
<?
	/*
	This SQL query will create the table to store your object.

	CREATE TABLE `event` (
	`eventid` int(11) auto_increment,
	`bezeichnung` VARCHAR(255),
	`beschreibung` VARCHAR(255),
	`beginn` TIMESTAMP(19),
	`ende` TIMESTAMP(19),
	`maxteilnehmer` BIGINT,
	`ort` VARCHAR(255),
	`create_userid` BIGINT,
	`create_date` TIMESTAMP, PRIMARY KEY  (`eventid`));
	
	
	CREATE TABLE `kommentar` (
	`kommentarid` int(11) auto_increment,
	`text` VARCHAR(512),
	`erstdat` TIMESTAMP,
	`teilnehmer_fk` BIGINT,
	`event_fk` BIGINT, PRIMARY KEY  (`kommentarid`));
	
	
	CREATE TABLE `teilnehmer` (
	`teilnehmerid` int(11) auto_increment,
	`userid_fk` BIGINT,
	`event_fk` BIGINT,
	`status` VARCHAR(255), PRIMARY KEY  (`teilnehmerid`));
	
	
	CREATE TABLE `recht` (
	`rechtid` int(11) auto_increment,
	`beschreibung` VARCHAR(255),
	`key` VARCHAR(255),
	`name` VARCHAR(255), PRIMARY KEY  (`rechtid`));
	
	
	CREATE TABLE `recht2rolle` (
	`recht2rolleid` int(11) auto_increment,
	`recht_fk` BIGINT,
	`rolle_fk` BIGINT, PRIMARY KEY  (`recht2rolleid`));
	
	CREATE TABLE `rolle` (
	`rolleid` int(11) auto_increment,
	`name` VARCHAR(255),
	`default` SMALLINT, PRIMARY KEY  (`rolleid`));
	
	CREATE TABLE `user` (
	`userid` int(11) auto_increment,
	`name` VARCHAR(255),
	`password` VARCHAR(255),
	`email` VARCHAR(255),
	`status` INT, PRIMARY KEY  (`userid`));
	
	
	CREATE TABLE `user2rolle` (
	`user2rolleid` int(11) auto_increment,
	`user_fk` BIGINT,
	`rolle_fk` INT, PRIMARY KEY  (`user2rolleid`));
	
	*/
	require("../Shared/sharedfunctions.php");
	require_once("../UserMan/controller/objects/class.recht.php");
	require_once("../UserMan/controller/objects/class.recht2rolle.php");
	require_once("../UserMan/controller/objects/class.rolle.php");
	require_once("../UserMan/controller/objects/class.user.php");
	require_once("../UserMan/controller/objects/class.user2rolle.php");
	
	echo 'Initialisiere Daten...<br>';
	#Admin anlegen
	
	echo "Creating admin user...<br>";
	$entity_user = new User();
	
	$entity_user->name="Administrator";
	$entity_user->password="admin";
	$entity_user->email="webmaster@dynamicvisions.de";
	$entity_user->status=$entity_user->ADMIN;
	
	$entity_user->userId = $entity_user->SaveNew();
	
	echo "Creating super role<br>";
	$entity_rolle = new Rolle();
	$entity_rolle->name="GOD";
	$entity_rolle->rolleId=$entity_rolle->SaveNew();
	
	$entity_user->addRolle($entity_rolle->rolleId);
	
	echo "Creating rights...<br>";
	$entity_recht = new Recht();
	$entity_recht->name="Alle Events anzeigen";
	$entity_recht->beschreibung="Listet alle Events auf. Normalerweise sieht jeder User nur die ihm zugeordneten.";
	$entity_recht->key="seeallevents";
	$entity_rolle->addRecht($entity_recht->SaveNew());

	$entity_recht->name="Event bearbeiten";
	$entity_recht->beschreibung="Berechtigung zum Bearbeiten  eine Events. Ohne dieses ist die Detailmaske nicht aufrufbar.";
	$entity_recht->key="editevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());

	$entity_recht->name="Event anlegen";
	$entity_recht->beschreibung="Ntig, um ein neues Event einrichten zu knnen.";
	$entity_recht->key="addevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Event lschen";
	$entity_recht->beschreibung="Lschen eines Eventes inkls aller Abhngigkeiten.";
	$entity_recht->key="deleteevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Event speichern";
	$entity_recht->beschreibung="Speichert die nderungen, die an einem Event vorgenommen wurden.";
	$entity_recht->key="updateevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Einladungen senden";
	$entity_recht->beschreibung="Berechtigung, um Einladungen verschicken zu drfen.";
	$entity_recht->key="sendinvitations";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Kommentar verfassen";
	$entity_recht->beschreibung="Benutzer knnen zu einem Event Kommentare schreiben.";
	$entity_recht->key="commentevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Kommentar lschen";
	$entity_recht->beschreibung="Derf Schein zum Lschen eines Kommentares.";
	$entity_recht->key="deletecomment";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Teilnehmer einladen";
	$entity_recht->beschreibung="Teilnehmer auf die Gsteliste setzen.";
	$entity_recht->key="addteilnehmer";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	
	
	
	$entity_recht->name="Alle User anzeigen";
	$entity_recht->beschreibung="Benutzerverwaltung";
	$entity_recht->key="seealluser";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Benutzer bearbeitne";
	$entity_recht->beschreibung="";
	$entity_recht->key="edituser";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Bearbeiteten User speichern";
	$entity_recht->beschreibung="";
	$entity_recht->key="saveedituser";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
		
	
	$entity_recht->name="Benutzer hinzufgen";
	$entity_recht->beschreibung="";
	$entity_recht->key="adduser";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Benutzer lschen";
	$entity_recht->beschreibung="";
	$entity_recht->key="deleteuser";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Rolle hinzufgen";
	$entity_recht->beschreibung="";
	$entity_recht->key="addrole";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Rolle anlegen";
	$entity_recht->beschreibung="";
	$entity_recht->key="createrole";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Rolle bearbeiten";
	$entity_recht->beschreibung="";
	$entity_recht->key="editrole";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Rolle speichern";
	$entity_recht->beschreibung="";
	$entity_recht->key="updaterole";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Rolle entfernen";
	$entity_recht->beschreibung="";
	$entity_recht->key="removerole";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Recht hinzufgen";
	$entity_recht->beschreibung="";
	$entity_recht->key="addright";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Recht erstellen";
	$entity_recht->beschreibung="";
	$entity_recht->key="createright";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Recht bearbeiten";
	$entity_recht->beschreibung="";
	$entity_recht->key="editright";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Recht lschen";
	$entity_recht->beschreibung="";
	$entity_recht->key="deleteright";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Recht entfernen";
	$entity_recht->beschreibung="";
	$entity_recht->key="removeright";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	#$entity_recht->name="";
	#$entity_recht->beschreibung="";
	#$entity_recht->key="";
	#$entity_rolle->addRecht($entity_recht->SaveNew());
	
	
	
	
	echo "Creating another role...<br>";
	$entity_rolle = new Rolle();
	$entity_rolle->name="Veranstalter";
	$entity_rolle->rolleId=$entity_rolle->SaveNew();
	
	
	$entity_recht->name="Event bearbeiten";
	$entity_recht->beschreibung="Berechtigung zum Bearbeiten  eine Events. Ohne dieses ist die Detailmaske nicht aufrufbar.";
	$entity_recht->key="editevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());

	$entity_recht->name="Event anlegen";
	$entity_recht->beschreibung="Ntig, um ein neues Event einrichten zu knnen.";
	$entity_recht->key="addevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Event speichern";
	$entity_recht->beschreibung="Speichert die nderungen, die an einem Event vorgenommen wurden.";
	$entity_recht->key="updateevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Einladungen senden";
	$entity_recht->beschreibung="Berechtigung, um Einladungen verschicken zu drfen.";
	$entity_recht->key="sendinvitations";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Kommentar verfassen";
	$entity_recht->beschreibung="Benutzer knnen zu einem Event Kommentare schreiben.";
	$entity_recht->key="commentevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Kommentar lschen";
	$entity_recht->beschreibung="Derf Schein zum Lschen eines Kommentares.";
	$entity_recht->key="deletecomment";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Teilnehmer einladen";
	$entity_recht->beschreibung="Teilnehmer auf die Gsteliste setzen.";
	$entity_recht->key="addteilnehmer";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	
	
	
	$entity_recht->name="Benutzer bearbeiten";
	$entity_recht->beschreibung="";
	$entity_recht->key="edituser";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	$entity_recht->name="Bearbeiteten User speichern";
	$entity_recht->beschreibung="";
	$entity_recht->key="saveedituser";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	
	
	
	echo "Creating another role...<br>";
	$entity_rolle = new Rolle();
	$entity_rolle->name="Teilnehmer";
	$entity_rolle->default=1;
	$entity_rolle->rolleId=$entity_rolle->SaveNew();
	
	
	$entity_recht->name="Event bearbeiten";
	$entity_recht->beschreibung="Berechtigung zum Bearbeiten  eine Events. Ohne dieses ist die Detailmaske nicht aufrufbar.";
	$entity_recht->key="editevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());

	$entity_recht->name="Kommentar verfassen";
	$entity_recht->beschreibung="Benutzer knnen zu einem Event Kommentare schreiben.";
	$entity_recht->key="commentevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	
	
	
	$entity_recht->name="Benutzer bearbeiten";
	$entity_recht->beschreibung="";
	$entity_recht->key="edituser";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	
	
	
	echo "Creating another role...<br>";
	
	$entity_rolle = new Rolle();
	$entity_rolle->name="Gast";
	$entity_rolle->default=1;
	$entity_rolle->rolleId=$entity_rolle->SaveNew();
	
	
	$entity_recht->name="Event bearbeiten";
	$entity_recht->beschreibung="Berechtigung zum Bearbeiten  eine Events. Ohne dieses ist die Detailmaske nicht aufrufbar.";
	$entity_recht->key="editevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());

	$entity_recht->name="Kommentar verfassen";
	$entity_recht->beschreibung="Benutzer knnen zu einem Event Kommentare schreiben.";
	$entity_recht->key="commentevent";
	$entity_rolle->addRecht($entity_recht->SaveNew());
	
	
	
	echo 'Fertig';
?>