<?php
/*
	This SQL query will create the table to store your object.

	CREATE TABLE `text` (
	`textid` int(11) auto_increment,
	`text` BLOB,
	`createdatetime` TIMESTAMP,
	`changedatetime` TIMESTAMP,
	`createuser` INT,
	`changeuser` INT,
	`title` VARCHAR(255),
	`category` VARCHAR(255), PRIMARY KEY  (`textid`));
*/

/**
* <b>Text</b> class with integrated CRUD methods.
* @author Php Object Generator
* @version 1.6 rc1
* @copyright Free for personal & commercial use. (Offered under the BSD license)
* @link http://www.phpobjectgenerator.com/?language=php4&wrapper=pog&objectName=Text&attributeList=array+%28%0A++0+%3D%3E+%27text%27%2C%0A++1+%3D%3E+%27createdatetime%27%2C%0A++2+%3D%3E+%27changedatetime%27%2C%0A++3+%3D%3E+%27createuser%27%2C%0A++4+%3D%3E+%27changeuser%27%2C%0A++5+%3D%3E+%27title%27%2C%0A++6+%3D%3E+%27category%27%2C%0A%29&typeList=array+%28%0A++0+%3D%3E+%27BLOB%27%2C%0A++1+%3D%3E+%27TIMESTAMP%27%2C%0A++2+%3D%3E+%27TIMESTAMP%27%2C%0A++3+%3D%3E+%27INT%27%2C%0A++4+%3D%3E+%27INT%27%2C%0A++5+%3D%3E+%27VARCHAR%28255%29%27%2C%0A++6+%3D%3E+%27VARCHAR%28255%29%27%2C%0A%29
*/
class Text
{
	var $textId;
	var $text;
	var $createdatetime;
	var $changedatetime;
	var $createuser;
	var $changeuser;
	var $title;
	var $category;
	var $pog_attribute_type = array(
		"textid" => array("NUMERIC", "INT"),
		"text" => array("TEXT", "BLOB"),
		"createdatetime" => array("NUMERIC", "TIMESTAMP"),
		"changedatetime" => array("NUMERIC", "TIMESTAMP"),
		"createuser" => array("NUMERIC", "INT"),
		"changeuser" => array("NUMERIC", "INT"),
		"title" => array("TEXT", "VARCHAR", "255"),
		"category" => array("TEXT", "VARCHAR", "255"),
		);
	var $pog_query;
	
	function Text($text='', $createdatetime='', $changedatetime='', $createuser='', $changeuser='', $title='', $category='')
	{
		$this->text = $text;
		$this->createdatetime = $createdatetime;
		$this->changedatetime = $changedatetime;
		$this->createuser = $createuser;
		$this->changeuser = $changeuser;
		$this->title = $title;
		$this->category = $category;
	}
	
	
	/**
	* Gets object from database
	* @param integer $textId 
	* @return object $Text
	*/
	function Get($textId)
	{
		$Database = new DatabaseConnection();
		$this->pog_query = "select * from `text` where `textid`='".intval($textId)."' LIMIT 1";
		$Database->Query($this->pog_query);
		$this->textId = $Database->Result(0, "textid");
		$this->text = $Database->Unescape($Database->Result(0, "text"));
		$this->createdatetime = $Database->Result(0, "createdatetime");
		$this->changedatetime = $Database->Result(0, "changedatetime");
		$this->createuser = $Database->Unescape($Database->Result(0, "createuser"));
		$this->changeuser = $Database->Unescape($Database->Result(0, "changeuser"));
		$this->title = $Database->Unescape($Database->Result(0, "title"));
		$this->category = $Database->Unescape($Database->Result(0, "category"));
		return $this;
	}
	
	
	/**
	* Returns a sorted array of objects that match given conditions
	* @param multidimensional array {("field", "comparator", "value"), ("field", "comparator", "value"), ...} 
	* @param string $sortBy 
	* @param boolean $ascending 
	* @param int limit 
	* @return array $textList
	*/
	function GetList($fcv_array, $sortBy='', $ascending=true, $limit='')
	{
		$sqlLimit = ($limit != '' && $sortBy == ''?"LIMIT $limit":'');
		if (sizeof($fcv_array) > 0)
		{
			$textList = Array();
			$Database = new DatabaseConnection();
			$this->pog_query = "select textid from `text` where ";
			for ($i=0, $c=sizeof($fcv_array)-1; $i<$c; $i++)
			{
				$this->pog_query .= "`".strtolower($fcv_array[$i][0])."` ".$fcv_array[$i][1]." '".$Database->Escape($fcv_array[$i][2])."' AND";
			}
			$this->pog_query .= "`".strtolower($fcv_array[$i][0])."` ".$fcv_array[$i][1]." '".$Database->Escape($fcv_array[$i][2])."' order by textid asc $sqlLimit";
			$Database->Query($this->pog_query);
			for ($i=0; $i < $Database->Rows(); $i++)
			{
				$text = new Text();
				$text->Get($Database->Result($i, "textid"));
				$textList[] = $text;
			}
			if ($sortBy != '')
			{
				$f = '';
				$text = new Text();
				if (isset($text->pog_attribute_type[strtolower($sortBy)]) && $text->pog_attribute_type[strtolower($sortBy)][0] == "NUMERIC")
				{
					$f = 'return $text1->'.$sortBy.' > $text2->'.$sortBy.';';
				}
				else if (isset($text->pog_attribute_type[strtolower($sortBy)]))
				{
					$f = 'return strcmp(strtolower($text1->'.$sortBy.'), strtolower($text2->'.$sortBy.'));';
				}
				usort($textList, create_function('$text1, $text2', $f));
				if (!$ascending)
				{
					$textList = array_reverse($textList);
				}
				if ($limit != '')
				{
					return array_slice($textList, 0, $limit);
				}
			}
			return $textList;
		}
		return null;
	}
	
	
	function SaveWithCurrentTimeAndUser() {
		$timestamp=time();
		$this->createdatetime=$dateTimeFormatter->timeStamp2MySQLDateTime($timestamp);
		$this->changedatetime=$dateTimeFormatter->timeStamp2MySQLDateTime($timestamp);
		$this->changeuser=$userManager->getCurrentLoggedInUser();					
	}
	
	/**
	* Saves the object to the database
	* @return integer $textId
	*/
	function Save()
	{
		
		$dateTimeFormatter = new DateTimeFormatter();
		$userManager = new UserManager();
		$Database = new DatabaseConnection();
		$this->pog_query = "select textid from `text` where `textid`='".$this->textId."' LIMIT 1";
		$Database->Query($this->pog_query);
		if ($Database->Rows() > 0)
		{
			$this->pog_query = "update `text` set 
			`text`='".$Database->Escape($this->text)."', 
			`createdatetime`='".$this->createdatetime."', 
			`changedatetime`='".$this->changedatetime."', 
			`createuser`='".$Database->Escape($this->createuser)."', 
			`changeuser`='".$Database->Escape($this->changeuser)."', 
			`title`='".$Database->Escape($this->title)."', 
			`category`='".$Database->Escape($this->category)."' where `textid`='".$this->textId."'";
		}
		else
		{	
			$this->changeuser=$userManager->getCurrentLoggedInUser();
			$this->createuser=$userManager->getCurrentLoggedInUser();
			$this->pog_query = "insert into `text` (`text`, `createdatetime`, `changedatetime`, `createuser`, `changeuser`, `title`, `category` ) values (
			'".$Database->Escape($this->text)."', 
			'".$this->createdatetime."', 
			'".$this->changedatetime."', 
			'".$Database->Escape($this->createuser)."', 
			'".$Database->Escape($this->changeuser)."', 
			'".$Database->Escape($this->title)."', 
			'".$Database->Escape($this->category)."' )";
		}
		$Database->InsertOrUpdate($this->pog_query);
		if ($this->textId == "")
		{
			$this->textId = $Database->GetCurrentId();
		}
		return $this->textId;
	}
	
	
	/**
	* Clones the object and saves it to the database
	* @return integer $textId
	*/
	function SaveNew()
	{
		$this->textId = '';
		return $this->Save();
	}
	
	
	/**
	* Deletes the object from the database
	* @return boolean
	*/
	function Delete()
	{
		$Database = new DatabaseConnection();
		$this->pog_query = "delete from `text` where `textid`='".$this->textId."'";
		return $Database->Query($this->pog_query);
	}
}
?>