<?
	/*
	 * Eventmanager - Manage and organize events, meetings, partys online 
	 * Copyright (C) 2006 
	 * Sven O. Gabel - Sven.O.Gabel@dynamicvisions.de
	 * 
	 * This program is free software; you can redistribute it and/or modify it under the terms of 
	 * the GNU General Public License as published by the Free Software Foundation; either 
	 * version 2 of the License, or (at your option) any later version.
	 * This program is distributed in the hope that it will be useful, 
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
	 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
	 * 
	 * You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA 
	 * 
	 */
?>
<?
class RechteManager {

		function loadRoleByNameAndUser($strRoleName,$userId) {
			$entity_user = new User();
			$entity_user = $entity_user->Get($userId);
			$entity_rolle=$entity_user->getRoleOfUserByRoleName($strRoleName);
			return $entity_rolle;		
		}
		
		function loadRightByKeyAndRole($strRightKey,$entity_rolle) {			
			$entity_rolle = new Rolle();
			$entity_recht = $entity_rolle->GetRechtByKey($strRightKey);
			return $entity_recht;
		}
		
		
		function removeRightFromRoleOfUser($strRoleName,$strRightKey,$userId) {
			$entity_rolle = $this->loadRoleByNameAndUser($strRoleName,$userId);
			$entity_recht = $this->loadRightByKeyAndRole($strRightKey,$entity_rolle);
			if($entity_recht)
				$entity_recht->Delete();
		}
		
		function addRightToRoleOfUser($strRoleName,$strRightKey,$userId) {
			$entity_rolle = $this->loadRoleByNameAndUser($strRoleName,$userId);
			//if Role does not exist yet, it must be created;
			if(!$entity_rolle) {
				$entity_rolle = new Rolle();
				$entity_rolle->name=$strRoleName;
				$entity_rolle->rolleId=$entity_rolle->Save();
				$entity_user = new User();
				$entity_user=$entity_user->Get($userId);
				$entity_user->addRolle($entity_rolle->rolleId);
			}
			
			$entity_recht=$this->loadRightByKeyAndRole($strRightKey,$entity_rolle);
			if(!$entity_recht) {
				$entity_recht = new Recht();
				$entity_recht->key=$strRightKey;
				$entity_recht->name='Right for Key '.$strRightKey;
				$entity_recht->rechtId=$entity_recht->Save();	
				$entity_rolle->addRecht($entity_recht->rechtId);	
			}
			
		}

		function loadRechte() {
			return $this->loadRechteForUser($_SESSION['loggedinuserid']);			
		}
		
		function loadRechteForUser($tmpUserId) {
			$allerechte = Array();
			if(!$tmpUserId)
				return $allerechte;
			$entity_user = new User();
			$entity_user = $entity_user->Get($tmpUserId);
			#echo '<br>current User:'.$entity_user->name;
			$rollenList = $entity_user->GetRollen();			
			for ($i=0; $i<sizeof($rollenList); $i++)
			{
				#echo '<br>current role:'.$rollenList[$i]->name;
				$rechteListe = $rollenList[$i]->GetRechte();
				
				for($x=0; $x<sizeOf($rechteListe); $x++ ) 
				{
					#echo '<br>adding right:'.$rechteListe[$x]->name;
					array_push($allerechte,$rechteListe[$x]->key);
				} 
			}	
			return $allerechte;					
		}
	
		function loadRechteForRolle($rolleName,$tmpUserId) {
			$allerechte = Array();
			if(!$tmpUserId)
				return $allerechte;
			$entity_user = new User();
			/*if(!isset($_SESSION['loggedinuserid']))
				return $allerechte;
			$tmpUserId = $_SESSION['loggedinuserid'];
			*/
			$entity_user = $entity_user->Get($tmpUserId);
			#echo '<br>current User:'.$entity_user->name;
			$entity_rolle = new Rolle();
			$entity_rolle = $entity_rolle->GetRolleByName($rolleName);
			if($entity_rolle) {
			$rechteListe = $entity_rolle->GetRechte();
				for($x=0; $x<sizeOf($rechteListe); $x++ ) 
				{
					#echo '<br>adding right:'.$rechteListe[$x]->name;
					array_push($allerechte,$rechteListe[$x]->key);
				} 
			}
			return $allerechte;					
		}
	
		
	
		function findUsersForRight($rechteKey) {
			
			$entity_recht=new Recht();
			$completeUserListe=array();
			$rechteListe=$entity_recht->GetList(array(array("key","=",$rechteKey)));
			if(sizeof($rechteListe)==0)
				return $completeUserListe;
			for ($x=0; $x<sizeof($rechteListe); $x++)
			{
			$entity_recht=$rechteListe[$x];
			$rollenListe=$entity_recht->GetRollen();
				for ($i=0; $i<sizeof($rollenListe); $i++)
				{
					$userListe=$rollenListe[$i]->getUsers();
					
					
					for ($z=0; $z<sizeof($userListe); $z++)
					{
						$oneUser = $userListe[$z];
						array_push($completeUserListe,$oneUser);
					} 
				}
			}
			return $completeUserListe;
		}
		
		function checkCredential($rechteKey) {
			return $allerechte = $this->checkCredentialForUser($rechteKey,$_SESSION['loggedinuserid']);
		}
		
		function checkCredentialForUser($rechteKey,$userId) {
			$allerechte = $this->loadRechteForUser($userId);
			if( in_array($rechteKey, $allerechte) ) {
				return true;
			}else{
				return false;
			}	
		}
		
		function isUserAdmin() {
			$userRechte =new UserManRecht();		
			#echo 'is God:'.$this->checkCredential($userRechte->GOD_RIGHT);	
			return $this->checkCredential($userRechte->GOD_RIGHT);
		}
		
		function isAllowedFor($rechteKey) {
			//echo 'Checke Key:'.$rechteKey;
			if($this->isUserAdmin())
				return true;
			//echo 'Ist kein ADmin:';
			return $this->checkCredential($rechteKey);
		}
		
			
	}
	?>